#ifndef AOUTHDR_H
#define AOUTHDR_H

/*
 * SCCS:	@(#)aouthdr.h	6.3	90/03/27	(c) ACE
 *
 * ACE-COFF Utilities.
 *
 * This source file is part of the ACE Compiler Family.
 * Copyright reserved. This source file, or parts of it, may not
 * be reproduced or transmitted in any form, including reprinting,
 * photocopying or microfilming, or by any means, electronic,
 * mechanical or otherwise, or stored in a retrieval system,
 * or used for any purpose, without the prior written permission
 * of ACE Associated Computer Experts bv.
 * This source file is derived from UNIX System 5.0 (Copyright AT&T)
 *
 * (c) 1985 ACE Associated Computer Experts bv, Amsterdam
 *
 */


/*
 * ACE_COFF aouthdr layout defined 85/01/04;
 * compatible with 5.2 if ACE_COFF is not defined;
 * only entry is used by the ACE kernel.
 */


typedef	struct aouthdr {
	short	magic;
	short	vstamp;		/* version stamp			*/
	long	tsize;		/* text size in bytes, padded to FW
				   bdry					*/
	long	dsize;		/* initialized data "  "		*/
	long	bsize;		/* uninitialized data "   "		*/
#if U3B
	long	dum1;
	long	dum2;		/* pad to entry point	*/
#endif
#ifdef vms
	long	ventry;		/* entry pt.				*/
#else
	long	entry;		/* entry pt.				*/
#endif
	long	text_start;	/* base of text used for this file	*/
	long	data_start;	/* base of data used for this file	*/
#ifdef ACE_COFF
	long	ssize;		/* string table length */
#endif /* ACE_COFF */
} AOUTHDR;

#if U3B

#ifdef ACE_COFF
#define AOUTHSZ	40
#else not ACE_COFF
#define AOUTHSZ	36
#endif /* not ACE_COFF */

#else not U3B

#ifdef ACE_COFF
#define AOUTHSZ	32
#else not ACE_COFF
#define AOUTHSZ	28
#endif /* not ACE_COFF */

#endif /* not U3B */

#endif /* AOUTHDR_H */
