
#define BASE 			1		/*  Loop index */
#define COUNT			2		/*  Loop count */
#define LOAD_START		0		/*  Start of loader */
#define LOAD_LENGTH		1		/*  Loader block length */
#define NEXT_ADDRESS		2		/*  Start of next block  */
#define BOOTLINK		3		/*  Link booted from */

#define NOTPROCESS		6		/*  Copy of MinInt */

#define LINKS			NOTPROCESS	/*  1st parameter to loader */
#define BOOTLINK_IN_PARAM	7		/*  2nd parameter to loader */
#define BOOTLINK_OUT_PARAM	8		/*  3rd parameter to loader */
#define MEMORY			9		/*  4th parameter to loader */
#define BUFFER			10		/*  5th parameter to loader */
#define NEXT_POINT		11		/*  6th parameter to loader */
#define ENTRY_POINT		12		/*  7th parameter to loader */
#define DATA_POINT		13		/*  8th parameter to loader */
#define DATA_ADDRESS		14		/*  Referenced from entry point */
#define ENTRY_ADDRESS		15		/*  Referenced from data point */
#define NEXT_ADDRESS_POINTER	16		/*  Start of boot part 2 */

#define SECONDARY_START		17		/*  Start of secondary booter */

#define NUMBER_TO_INITIALISE	11

#define INITIAL_ADJUSTMENT	144             /*  Workspace adjustment for loaders */
#define WORKSPACE_SIZE		720             /*  Workspace required for secondary loader in bytes */
#define PARAMETER_BLOCK		LINKS           /*  Parameter block to secondary loader */
 
