#include "primary.h"

	.globl Primary
Primary:


    ajw    INITIAL_ADJUSTMENT 	/*  see above */
    call   0                	/*  save registers */

    ldc    EndOfPrimary - Addr0 /*  load secondary after primary */
    ldpi                    	/*  address of start */
Addr0:
    ldc    WORKSPACE_SIZE	/*  length of workspace in bytes */
    add
    stl    SECONDARY_START  	/*  free memory starts here */

    mint
    stl    NOTPROCESS       	/*  save for later use */

/*  initialise process queues and clear error */
    ldl    NOTPROCESS
    stlf                    	/*  reset low priority queue */

    ldl    NOTPROCESS
    sthf                    	/*  reset high priority queue */

    clrhalterr
    testerr                 	/*  read and clear error bit */

    fptesterr            	/*  floating check and clear error instruction */

/*  initialise link and event words */
    ldc    0
    stl    BASE             	/*  index to words to initialise */
    ldc    NUMBER_TO_INITIALISE /*  no. words to initialise */
    stl    COUNT            	/*  count of words left */
Startloop:
    ldl    NOTPROCESS
    ldl    BASE             	/*  index */
    ldl    NOTPROCESS
    wsub                    	/*  point to next address */
    stnl   0                	/*  put NotProcess into addressed word */
    ldlp   BASE             	/*  address of loop control info */
    ldc    Endloop - Startloop 	/*  return jump */
    lend                    	/*  go back if more */
Endloop:

/*  set up some loader parameters. See the parameter */
/*  structure of the loader Done here so that the secondary is smaller */

    ldlp   DATA_ADDRESS    	/*  address of entry word */
    stl    DATA_POINT      	/*  store in param 7 */

    ldlp   ENTRY_ADDRESS    	/*  address of entry word */
    stl    ENTRY_POINT      	/*  store in param 6 */

    ldlp   NEXT_ADDRESS_POINTER	/*  Next code address (to be used to overlay loader) */
    stl    NEXT_POINT     	/*  buffer offset in param 5 */

    ldl    SECONDARY_START      /*  start of loader */
    ldc    Primary - Addr1    	/*  distance to start byte */
    ldpi                    	/*  address of start */
Addr1:
    stl    MEMORY           	/*  MemStart: Parameter 4 to loader */

    ldl    BOOTLINK         	/*  copy of bootlink */
    stl    BOOTLINK_IN_PARAM   	/*  store in param 2 */

    ldl	   BOOTLINK	
    ldnlp  -4		    	/*  Calculate the output link address */
    stl    BOOTLINK_OUT_PARAM  	/*  store in param 3 */
  
    ldlp   SECONDARY_START  	/*  area to load bootloader */
    ldl    BOOTLINK         	/*  address of link */
    ldnlp  -4		    	/*  Calculate the output link address */
    ldc    4                    /*  Inform server about the address */
    out

    ldl    SECONDARY_START      /*  area to load bootloader */
    stl    LOAD_START

LoadStart:
    ldlp   LOAD_LENGTH      	/*  packet size word */
    ldl    BOOTLINK         	/*  address of link */
    ldc    1                	/*  bytes to load */
    in                      	/*  input length byte */

    ldl    LOAD_LENGTH          /*  load until packet size == 0 */
    cj     LoadOver

    ldl    LOAD_START         	/*  area to load bootloader */
    ldl    BOOTLINK         	/*  address of link */
    ldl    LOAD_LENGTH      	/*  message length */
    in                      	/*  input bootloader */

    ldl    LOAD_START           /*  calculate next address */
    ldl    LOAD_LENGTH
    sum
    stl    LOAD_START
    j      LoadStart

/*  enter code just loaded */
LoadOver:


    ldl    SECONDARY_START  /*  start of loaded code */
    ldlp   PARAMETER_BLOCK  /*  Address of parameter block */
    ldc    0                /*  No MDL set up yet */
    ajw    -4               /*  Simulate XCC call */
    stl    1
    stl    2
    ldc    0
    stl    3
    gcall                   /*  enter secondary loader */
EndOfPrimary:



