/*{{{  includes and globs*/
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdio.h>
#include <netdb.h>
/*}}}*/
main(argc,argv)
   int argc; char *argv[];
   {
   /*{{{  defs*/
   int sock,length,running=1;
   struct sockaddr_in server,client;
   struct hostent *Info;
   int rval,i,namelen;
   char buff[65536];
   /*}}}*/

   /*{{{  setup socket*/
   sock=socket(AF_INET,SOCK_DGRAM,0);
   if (sock<0) { perror("opening datagram socket"); exit(1); }
   server.sin_family = AF_INET;
   server.sin_addr.s_addr = INADDR_ANY;
   server.sin_port = 0;
   
   if (bind(sock,&server,sizeof(server))<0)
      {
      perror("binding datagram socket");
      exit(1);
      }
   length=sizeof(server);
   if (getsockname(sock,&server,&length))
      {
      perror("getting socket name");
      exit(1);
      }
   printf("Socket has port %d\n",ntohs(server.sin_port));
   /*}}}*/
   while (running)
      {
      /*{{{  receive a message from a client*/
      namelen=sizeof(client);
      if ((rval=recvfrom(sock,buff,65536,0,&client,&namelen))<0)
        perror("reading stream message");
      else
      {
        printf("Received %d bytes\n",rval);
        for(i=0;i<rval;i++) running=running && (buff[i]==(char)(i&255));
        if (running) printf("Data checked and correct\n");
        else printf("Data incorrect (or stop code received)\n");
      }
      /*}}}*/
      /*{{{  print info about client*/
      printf(")\nPort number %d\n",(int)ntohs(client.sin_port));
      if ((Info=gethostbyaddr(&client.sin_addr,4,AF_INET))==NULL)
        { perror("Trying to find client info from address"); exit(1); }
      printf("Client on host %s (aliases:",Info->h_name);
      for(i=0;(Info->h_aliases[i])!=NULL;i++) printf(" %s",Info->h_aliases[i]);
      /*}}}*/
      }
   if (shutdown(sock,2)<0) {perror("shutdown : "); exit(1);}
   printf("Server terminating\n");
   close(sock);
   }
