/*	Global variables used by VCP
*/

/*	Sender thread for each link
*/
Process 	*SenderProc[NUM_LINKS];

/*	Receiver thread for each link
*/
Process 	*ReceiverProc[NUM_LINKS];

/*	Timer thread for each link
*/
Process 	*TimerProc[NUM_LINKS];

/*	Timer Semaphore for each link
*/
Semaphore 	TimerSemaphore[NUM_LINKS];

/*	Wait structure for each sender thread
*/
WAIT_STRUCT 	SenderWaitStruct[NUM_LINKS];

/*	Should all messages arriving on link be received?
*/
Boolean		VCP_ReceiveAllMessages[NUM_LINKS];

/*	Has the VCP been initialized?
*/
Boolean VCP_Initialized = False;

/*	Is VCP running on link
*/
Boolean		VCP_Running[NUM_LINKS];

/*	Queue of send requests for each link
*/
SEND_REQUEST	*SendRequestQ[NUM_LINKS];

/*	Queue of send requests that cannot be serviced yet
*/
SEND_REQUEST	*PendingSendRequests[NUM_LINKS];

/*	Queue of Acknowlegdements that should be sent
*/
ACK_TO_BE_SENT	*AckToBeSent[NUM_LINKS];

/*	Queue of timer requests for each link
*/
TIMER_REQUEST	*TimerRequestQ[NUM_LINKS];

/*	Channels used to communicate to timer thread
*/
Channel *Timer_SenderChannel[NUM_LINKS], *Timer_ReceiverChannel[NUM_LINKS];

/*	Information on virtual channels that are currently in use
*/
VIRTUAL_CHAN_INFO	*VirtualChanInfo[NUM_LINKS][MAX_TABLE_SIZE];

/*	Packets that have arrived on each link
*/
PACKETS_RECEIVED *PacketsReceived[NUM_LINKS][MAX_TABLE_SIZE];

/*	List of messages for each link
*/
MESSAGE_LIST	*ListOfMessages[NUM_LINKS];

/*	Wait structure for ReceiveAll threads
*/
WAIT_STRUCT	ReceiveWaitStruct[NUM_LINKS];

/*	Physical channel addresses
*/
Channel *ReceiveChannels[] = { LINK0IN, LINK1IN, LINK2IN, LINK3IN };
Channel *SendChannels[] = { LINK0OUT, LINK1OUT, LINK2OUT, LINK3OUT };

