#ifndef _SIGNAL_H
#define _SIGNAL_H

/* SCCSID @(#)signal.h	7.9 92/11/12 */

#ifndef __STDC__
int	(*signal())();
#else	/* __STDC__ */
void	(*signal(int _sig, void (*_func)(int)))(int);
#endif

#ifndef __STDC__
#if lint
#define	SIG_DFL	((int (*)())0)
#define	SIG_ERR	((int (*)())0)
#define	SIG_IGN	((int (*)())0)
#else	/* !lint */
#define	SIG_DFL	((int (*)())0)
#define	SIG_ERR	((int (*)())-1)
#define	SIG_IGN	((int (*)())1)
#endif	/* lint */
#else	/* __STDC__ */
#define SIG_DFL ((void (*)())0)
#define	SIG_ERR	((void (*)())-1)
#define	SIG_IGN	((void (*)())1)
#endif

#define	SIGHUP	1	/*  XPG3: Hangup */
#define	SIGINT	2	/* ISO-C: Terminal interrupt signal */
#define	SIGQUIT	3	/*  XPG3: Terminal quit signal */
#define	SIGILL	4	/* ISO-C: Illegal instruction (not reset when caught) */
#define	SIGTRAP	5	/*  xpg2: trace trap (not reset when caught) */
/* constants 6 and 7 have been removed */
#define	SIGFPE	8	/* ISO-C: Floating-point exception */
#define	SIGKILL	9	/*  XPG3: Kill (cannot be caught or ignored) */
/* constant 10 has been removed */
#define	SIGSEGV	11	/* ISO-C: Invalid memory reference */
#define	SIGSYS	12	/*  xpg2: bad argument to system call */
#define	SIGPIPE	13	/*  XPG3: Write on a pipe with no one to read it */
#define	SIGALRM	14	/*  XPG3: Alarm clock */
#define	SIGTERM	15	/* ISO-C: Termination signal */
#define	SIGUSR1	16	/*  XPG3: User-defined signal 1 */
#define	SIGUSR2	17	/*  XPG3: User-defined signal 2 */
#define	SIGCHLD	18	/*  XPG3: Child process terminated or stopped */
#define	SIGCLD	SIGCHLD	/* backward compatible with SVID */

#ifdef mc68000
#define	SIGPWR	19	/* power-fail restart */
#endif

#define SIGABRT	20	/* ISO-C: Process abort signal */
#define SIGGROW	21	/* no recoverable stack grow */
#define SIGFAIL	22	/* no recoverable system failure */

#ifdef mc68000
#define	SIGCHK	23	/* chk instruction */
#define	SIGZDV	24	/* zero divide */
#define	SIGTRV	25	/* trapv instruction */
#define	SIGADR	26	/* address error */
#define	SIGEMT	27	/* EMT instruction */
#define	SIGURG	28	/* urgent condition on IO channel */
#define	SIGIO	29	/* input/output possible signal */
#define	SIGBUS	SIGSEGV	/* bus error, maps to segmentation violation */
#endif /* mc68000 */

/* constants 30 to NSIG are unused */
#ifndef __STDC__
/* xpg2 signal(5): 
**	"The include file contains a statement to define the
**	 symbolic constant NSIG which is machine dependent"
** ACE chose to make NSIG equal to the highest allowable signal number.
*/
#define	NSIG	32
#endif

#ifndef __STDC__
int	raise();
#else
int	raise(int _sig);
#endif

/* ISO-C: */
typedef int	sig_atomic_t;

/* New for XPG3: */
#ifndef __STDC__

typedef struct { unsigned int s[2]; } sigset_t;

struct sigaction {
	void (*sa_handler)();
	sigset_t sa_mask;
	int sa_flags;
};

#define	SA_NOCLDSTOP	1

#define	SIG_BLOCK	2
#define	SIG_UNBLOCK	4
#define	SIG_SETMASK	8

extern int	kill();
extern int	sigaction();
extern int	sigaddset();
extern int	sigdelset();
extern int	sigemptyset();
extern int	sigfillset();
extern int	sigismember();
extern int	sigpending();
extern int	sigprocmask();
extern int	sigsuspend();

#endif	/* __STDC__ */

/** Introduced for sockets
**/
#define	SIGURG	16
#define SIGIO	23

#endif /* _SIGNAL_H */
